"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const __1 = require("..");
exports.command = 'hook';
exports.desc = 'Show hook info';
exports.builder = function (yargs) { };
exports.handler = function (argv) {
    return __awaiter(this, void 0, void 0, function* () {
        try {
            const hookInfo = yield __1.Utils.invokeHook('hook', {
                mode: 'group'
            });
            const columns = [['Hook', 'Package', 'Description']];
            Object.keys(hookInfo).map(k => {
                Object.keys(hookInfo[k]).map(hook => {
                    let realHook;
                    if (k === argv.scriptName) {
                        realHook = hook;
                    }
                    else {
                        let pluginShortName = k.substring(`${argv.scriptName}-plugin-`.length);
                        realHook = hook.indexOf(`${pluginShortName}_`) === 0 ? hook : `${pluginShortName}_${hook}`;
                    }
                    columns.push([`hook_${realHook}`, k, hookInfo[k][hook]]);
                });
            });
            __1.Utils.log(__1.Utils.table(columns));
        }
        catch (e) {
            __1.Utils.error(e.stack);
        }
    });
};
//# sourceMappingURL=hook.js.map