"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = __importDefault(require("path"));
const lodash_1 = __importDefault(require("lodash"));
const yargs_parser_1 = __importDefault(require("yargs-parser"));
const __1 = require("..");
exports.command = 'script [file]';
exports.aliases = 'scr';
exports.desc = 'Execute a script';
exports.builder = function (yargs) {
    const parsedArgv = yargs_parser_1.default(process.argv.slice(2));
    let filePath = parsedArgv._[1];
    if (!parsedArgv.help && !parsedArgv.h) {
        if (!__1.Utils.fileExistsSyncCache(filePath)) {
            filePath = path_1.default.resolve(process.cwd(), filePath);
        }
        else {
            filePath = path_1.default.resolve(filePath);
        }
        const scriptModule = require(filePath);
        if (lodash_1.default.isFunction(scriptModule.builder)) {
            scriptModule.builder(yargs);
        }
    }
};
exports.handler = function (argv) {
    return __awaiter(this, void 0, void 0, function* () {
        try {
            let filePath = argv.file;
            if (!__1.Utils.fileExistsSyncCache(filePath)) {
                filePath = path_1.default.resolve(process.cwd(), argv.file);
            }
            else {
                filePath = path_1.default.resolve(argv.file);
            }
            const scriptModule = require(filePath);
            if (!lodash_1.default.isFunction(scriptModule.handler)) {
                throw new Error('Script handler not exist!');
            }
            yield scriptModule.handler(argv);
        }
        catch (e) {
            __1.Utils.error(e.stack);
        }
    });
};
//# sourceMappingURL=script.js.map