"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = __importDefault(require("path"));
const os_1 = __importDefault(require("os"));
const envinfo_1 = __importDefault(require("envinfo"));
const __1 = require("..");
exports.hook_hook = {
    beforeCommand: 'Hook triggered before command execution.',
    afterCommand: 'Hook triggered after command execution.',
    components: 'Hook triggered when needing to fetch components',
    hook: 'Hook triggered in hook command.',
    repl: 'Hook triggered in repl command.',
    status: 'Hook triggered in status command.',
    new_repo: 'Hook triggered in new command.'
};
exports.hook_new_repo = () => {
    const argv = __1.Utils.getInternalCache().get('argv');
    const scriptName = argv && argv.scriptName ? argv.scriptName : 'zignis';
    return scriptName === 'zignis' ? {
        zignis_plugin_starter: {
            repo: 'git@github.com:zhike-team/zignis-plugin-starter.git',
            branch: 'master',
            alias: ['zignis-plugin-starter', 'plugin']
        }
    } : {};
};
exports.hook_status = () => __awaiter(void 0, void 0, void 0, function* () {
    let info = JSON.parse(yield envinfo_1.default.run({
        System: ['OS', 'Shell'],
        Binaries: ['Node', 'Yarn', 'npm']
    }, { json: true }));
    let kvs = {};
    const appConfig = __1.Utils.getApplicationConfig(path_1.default.resolve(__dirname, '../../'));
    kvs = Object.assign(kvs, __1.Utils._.pickBy({
        version: appConfig.version,
        location: appConfig.applicationDir.indexOf(process.env.HOME) === 0
            ? appConfig.applicationDir.replace(process.env.HOME, '~')
            : appConfig.applicationDir,
        os: info.System.OS,
        node: info.Binaries.Node ? info.Binaries.Node.version : null,
        npm: info.Binaries.npm ? info.Binaries.npm.version : null,
        yarn: info.Binaries.Yarn ? info.Binaries.Yarn.version : null,
        hostname: os_1.default.hostname(),
        home: process.env.HOME,
        shell: info.System.Shell.path
    }, __1.Utils._.identity));
    return kvs;
});
//# sourceMappingURL=index.js.map